// FPA10.h: interface for the CFPA10 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FPA10_H__3875F3CC_9F35_40D7_B290_6B7A46F15BBE__INCLUDED_)
#define AFX_FPA10_H__3875F3CC_9F35_40D7_B290_6B7A46F15BBE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ArmCoproc.h"

// There is a second coprocessor on coproc 2 for some transfers
class CFPA10_Slave : public CArmCoproc
{
public:
	// coproc num should be set as the above + 1
	CFPA10_Slave()  {}
	~CFPA10_Slave() {}

	void SetCoprocNum(Byte num) { coproc_num = num; }

	virtual BOOL DataOp(Word inst);
	virtual BOOL RegisterTransferOut(Word inst, Word data);
	virtual BOOL RegisterTransferIn(Word inst, Word* data);
	virtual BOOL DataTransferOut(Word inst);
	virtual BOOL DataTransferIn(Word inst);
};

class CFPA10 : public CArmCoproc  
{
	Byte sys_id;					// chip id. Could be loaded?

	CFPA10_Slave slave;				// only for FPA11

	DECLARE_COMPONENT(CFPA10);
public:
	CFPA10();
	virtual ~CFPA10();

	// CComponent interface
	virtual BOOL Reset();
	virtual BOOL Init();
	virtual BOOL Cleanup();

	// default is to return false - generates undefined instruction
	virtual BOOL DataOp(Word inst);
	virtual BOOL RegisterTransferOut(Word inst, Word data);
	virtual BOOL RegisterTransferIn(Word inst, Word* data);
	virtual BOOL DataTransferOut(Word inst);
	virtual BOOL DataTransferIn(Word inst);

};



#endif // !defined(AFX_FPA10_H__3875F3CC_9F35_40D7_B290_6B7A46F15BBE__INCLUDED_)
