// ArmCoproc.h: 
//
// Encapsulates the interface exported by Arm Coprocessors
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ARMCOPROC_H__CC761B61_E107_11D4_A272_0000F8002752__INCLUDED_)
#define AFX_ARMCOPROC_H__CC761B61_E107_11D4_A272_0000F8002752__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Component.h"
#include "ProcessorInterface.h"

class CArmCoproc : public CComponent
{
	IArmCoproc coproc;		// exported coprocessor interface
	IArmCoprocBus* bus;		// handle to the coprocessor bus

protected:
	Byte coproc_num;

	CArmCoproc(Byte num=0);

public:
	virtual ~CArmCoproc();

	// CComponent interface
	virtual BOOL Init();
	virtual BOOL Connect();
	virtual BOOL Disconnect();

	// Declared interface. Implementations should override these
	// to implemente the required coprocessor functionality
	virtual BOOL DataOp(Word inst) { return FALSE; }
	virtual BOOL RegisterTransferOut(Word inst, Word /*data */) { return FALSE; }
	virtual BOOL RegisterTransferIn(Word inst, Word* /*data*/) { return FALSE; }
	virtual BOOL DataTransferOut(Word Inst) { return FALSE; }
	virtual BOOL DataTransferIn(Word Inst) { return FALSE; }

	// Utility functions for data transfers. Returns FALSE for a DataAbort
	BOOL ReadWord(Word*);	// use the arm to read the next word from memory
	BOOL WriteWord(Word);	// use the arm to write a word to memory
};

#endif // !defined(AFX_ARMCOPROC_H__CC761B61_E107_11D4_A272_0000F8002752__INCLUDED_)
