// I2CDevice.h: interface for the CI2CDevice class.
//
// Virtual Base class for I2C devices. 
//
// Currently only used for the clock/nvram chip
//
//	Copyright (C) Magic Consulting Ltd 2000
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_I2CDEVICE_H__08E12CE5_F1F6_11D3_A88D_0000F8002752__INCLUDED_)
#define AFX_I2CDEVICE_H__08E12CE5_F1F6_11D3_A88D_0000F8002752__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Component.h"
#include "I2CInterface.h"

class CI2CDevice : public CComponent
{
	II2CDevice iface;			// our exported interface
	II2CBus* bus;				// handle to the i2cbus		
protected:
	Byte m_address;

	CI2CDevice();
public:
	virtual ~CI2CDevice();

	// CComponent interface
	virtual BOOL Init();
	virtual BOOL Connect();
	virtual BOOL Disconnect();

	// declared interface
	virtual Byte Read() { return 0; }
	virtual void Write(Byte /*b*/) {}

	virtual BOOL Select(Byte /*address*/) { return FALSE; }
	virtual void Deselect() {}
};


#endif // !defined(AFX_I2CDEVICE_H__08E12CE5_F1F6_11D3_A88D_0000F8002752__INCLUDED_)
